unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  FMX.StdCtrls, FMX.Layouts, FMX.Memo,
  uMy2DMatrix;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button4: TButton;
    Button5: TButton;
    Button7: TButton;
    Button6: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    FM1, FM2, FM3: TMy2DMatrix;
    procedure PopulateMatrix(AMatrix: TMy2dMatrix);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.fmx}


procedure TForm1.Button2Click(Sender: TObject);
begin
  FM2.Initialize(2,3);
  PopulateMatrix(FM2);
  Memo1.Lines.Add(' Init M2 ');
  Memo1.Lines.Add(FM2);
  Memo1.Lines.Add(' ');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  LTitle: string;
begin
  if RadioButton1.IsChecked then
  begin
    LTitle := 'M1 * M2';
    FM3 := FM1 * FM2;
  end
  else
  begin
    LTitle := 'M2 * M1';
    FM3 := FM2 * FM1;
  end;
  Memo1.Lines.Add(LTitle);
  Memo1.Lines.Add(FM3);
  Memo1.Lines.Add(' ');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  FM3 := 3 * FM1;
  Memo1.Lines.Add(' 3 * M1 ');
  Memo1.Lines.Add(FM3);
  Memo1.Lines.Add(' ');
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Memo1.Lines.Add(' M1 + M1 ');
  FM3 := FM1 + FM1;
  Memo1.Lines.Add(FM3);
  Memo1.Lines.Add(' ');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Memo1.Lines.Add(' M2 - M2 ');
  FM3 := FM2 - FM2;
  Memo1.Lines.Add(FM3);
  Memo1.Lines.Add(' ');
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  FM3 := FM1 * 3;
  Memo1.Lines.Add(' M1 * 3 ');
  Memo1.Lines.Add(FM3);
  Memo1.Lines.Add(' ');
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  LResult: string;
begin
  if FM1 = FM1 then
    LResult := 'True'
  else
    LResult := 'False';
  Memo1.Lines.Add(' M1 = M1 ');
  Memo1.Lines.Add(LResult);
end;

procedure TForm1.PopulateMatrix(AMatrix: TMy2dMatrix);
var
  I: Integer;
  J: Integer;
begin
  for I := 0 to AMatrix.Columns-1 do
    for J := 0 to AMatrix.Rows-1 do
      AMatrix[J, I] := I+J;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  LResult: string;
begin
  if FM1 = FM2 then
    LResult := 'True'
  else
    LResult := 'False';
  Memo1.Lines.Add(' M1 = M2 ');
  Memo1.Lines.Add(LResult);
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  LMA, LMB: TMy2DMatrix;
  LResult: string;
begin
  LMA := 3*FM1;
  LMB := FM1*3;
  if LMA = LMB then
    LResult := 'True'
  else
    LResult := 'False';
  Memo1.Lines.Add(' 3*M1 = M1*3 ');
  Memo1.Lines.Add(LResult);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FM1.Initialize(3, 2);
  PopulateMatrix(FM1);
  Memo1.Lines.Add(' Init M1 ');
  Memo1.Lines.Add(FM1);
  Memo1.Lines.Add(' ');
end;

end.
